#ifndef helpers_h
#define helpers_h
#endif /* helpers_h */
#include <utility>      // std::pair, std::make_pair
#include <string>
#include <fstream>
#include <iostream>
#include <vector>
#include <math.h>       /* erfc */
using namespace std;

/*converts the two bits input to a QAM signal
0b11 -> 3
0b10 -> 1
0b01 -> -1
0b00 -> -3

*/
pair<int, int> bits_to_QAM(int first, int second, int third, int fourth);
void QAM_to_bits(const vector<double> & in_phase, const vector<double> & quad, vector<uint8_t> & data);
void gray_to_bits(const vector<uint8_t> gray, vector<uint8_t> & data); //alternate, more general formulation
void compute_error_rates(string sent_message_filename, string rcvd_message_filename, double SNR);
