//
//  matched_filter.hpp
//  MatchedFilter
//
//  Created by Nathan Block on 1/27/20.
//  Copyright © 2020 Nathan Block. All rights reserved.
//

#ifndef matched_filter_hpp
#define matched_filter_hpp

#include <vector>
#include <stdio.h>
#include <math.h>
#include <stdint.h>

using namespace std;


class Matched_Filter_Bank{
public:
    Matched_Filter_Bank(long pulse_width, long periods_per_symbol, bool is_srrc);
    vector<vector<double> > filters;
    vector<double> squared_magnitudes;
    int num_filters;
    long signal_length;
    bool using_srrc;
};


int run_matched_filter(const vector<double> & stacked_signal, const Matched_Filter_Bank & my_filters, long sample_index, long cw_rate);
void convolve(const vector<double> & signal1, const vector<double> & signal2, vector<double> & output);
void stack_interleaving_signals(const vector<double> & raw_in_phase_stream, const vector<double> & raw_quadrature_stream, double symbol_width, long periods_per_symbol, long overlapping_samples, vector<vector<double> > & stacked_signals);
void matched_filter_handler(const vector<vector<double> > & stacked_signal, const Matched_Filter_Bank & my_filters, vector<uint8_t> & code_words, long cw_rate, long sample_rate);
double mag_diff(const vector<double> & received_signal, const vector<double> & expected_signal);
double magnitude_squared(const vector<double> & signal);

#endif /* matched_filter_hpp */
